JSX

코드 이해하기



```
import React from 'react';
```

리액트를 불러와서 사용할 수 있게해줌. 프로젝트를 만들때, node_modules디렉터리에

react모듈 설치 -> 불러와 사용



모듈 불러오는 기능은 브라우저에는 없던것 (Node.js에서 지원) Node.js는 import 가 아닌 require사용

-> 브라우저에서 사용하기 위해 번들러 사용(묶는다는 뜻) 대표적인 번들러 webpack

->번들러 사용하면 모듈을 불러왔을때 불러온 모듈 모두 합쳐 하나의 파일 생성 또는 최적화 여러개 분리

---

src/ index.js를 시작으로, 필요한 파일 다 불러와 번들링 브라우저도 import구문 사용할 수 있지만

프로젝트 번들링과는 다름

```
import logo from './logo.svg';

import './App.css';
```

웹팩을 사용하면 SVG,CSS 파일로 불러와 사용가능 (웹팩의 로더) css-loader, file-loader

bable-loader (최신자바스크립트 코드를 ES5로 변환) -> 구버전 브라우저와 호환하기 위해

CRA를 하면 자동으로 설정



```
function App() {
  return (
    <div className="App">
      <header className="App-header">
        <img src={logo} className="App-logo" alt="logo" />
        <p>
          Edit <code>src/App.js</code> and save to reload.
        </p>
        <a
          className="App-link"
          href="https://reactjs.org"
          target="_blank"
          rel="noopener noreferrer"
        >
          Learn React
        </a>
      </header>
    </div>
  );
}
```

APP 컴포넌트를 만들어줌 function키워드 사용했으니 함수형 컴포넌트

=>함수에서 반환하고 있는 내용을 나타냄 HTML이 아닌 JSX( 자바스크립트 확장 문법)

=> 번들링되어 일반자바스크립트 코드로 변환

---

```
function App(){
 return(
  <div>
   Hello<b>react</b>
  </div>
 );
}
```

```
function APP(){
 return React.createElement("div", null, "Hello", React.createElement("b",null,"react"))''
}
```



JSX 장점

보기쉽고 익숙, 높은 활용도

---

ReactDom.render

컴포넌트를 페이지에 렌더링 , react-dom 모듈을 불러와 사용가능, 첫번째 파라미터

페이지에 랜더링할 내용 JSX로 작성, 두번째 파라미터는 해당 JSX를 렌더링할 documnet내부 요소 설정

---

JSX 규칙

1.감싸인 요소

컴포넌트에 여러 요소가 있다면 반드시 부모 요소 하나로 감싸야 한다. ->

Virtual DOM에서 컴포넌트 변화를 감지해 낼 떄 효율적으로 비교할 수 있도록 컴포넌트 내부는

하나 이상의 DOM트리 구조로 이루어져야 한다

div, fragment,<>

2.자바스크립트 표현

JSX내부에서 자바스크립트 표현식 사용가능 중괄호{}로 감싸기

3.IF문 대신 조건부 연산자

JSX 내부의 자바스크립트 표현식에서 if문 사용불가 하지만 조건이 필요한 경우 {}안에 조건부 연산자

사용(삼항 연산자)

4.AND연산자 (&&)를 사용한 조건부 렌더링

```
name === '리액트' ? 리액트입니다 : null
```

```
name === '리액트' && 리액트입니다
```

false를 렌더링할 때 null과 마찬가지로 아무것도 나타지 않기 때문, falsy한 값인 0은 예외적으로

화면출력

JSX는 한줄로 표현가능하면 괄호로 감싸지 않고 아니면 괄호로 감싸도되고 감싸지 않아도된다

---

5.undefined 렌더링x

컴포넌트에서 undefined 반환하여 렌더링하는 상황 만들지말고, JSX내부에선 괜찮다

---

6.인라인스타일링

DOM요소에 스타일 적용할 때 객체 형태로 넣는다 - 문자를 없애고 카멜표기법으로 작성한다

ex) backgorund-color -> backgroundColor

font-size -> fontSize

font-weight  -> fontWeight

7.class 대신 className

8.꼭 닫아야 하는 태그

JSX에선 태그를 닫지 않으면 에러, 선언하면서 닫는 태그를 self-closing 태그라 부름

9.주석

{/**/} 주석

// /*는 그대로 페이지에 나타남

---

JSX는 HTML과 비슷하지만 완전히 똑같지는 않음, 코드로 보면 XML형식이지만 실제로는

자바스크립트 객체